import React, { Component } from "react";
import { BoundingRect, NormalizedAreaSelection, NormalizedPosition, SelectionType } from "../index";
import { Coords } from "./PdfViewer";
interface PdfPageProps {
    pageNumber: number;
    width?: number;
    selections?: SelectionType[];
    areaSelectionActive: boolean;
    enableAreaSelection?: (event: React.MouseEvent) => boolean;
    onAreaSelectionStart?: (pageNumber: number) => void;
    onAreaSelectionEnd?: (selection: NormalizedAreaSelection) => void;
}
interface PdfPageState {
    pageDimensions?: {
        width: number;
        height: number;
    };
    renderComplete: boolean;
    areaSelection?: {
        originTarget?: HTMLElement;
        start?: Coords;
        position?: NormalizedPosition;
        locked?: boolean;
    };
}
export declare class PdfPage extends Component<PdfPageProps, PdfPageState> {
    state: PdfPageState;
    inputRef: React.RefObject<HTMLDivElement>;
    containerCoords: (pageX: number, pageY: number) => {
        x: number;
        y: number;
    } | undefined;
    getBoundingRect(start: Coords, end: Coords, clip?: BoundingRect): BoundingRect;
    onAreaSelectStart: (event: React.MouseEvent) => void;
    getAreaSelectionPosition: (event: MouseEvent) => NormalizedPosition | undefined;
    onAreaSelectChange: (event: MouseEvent) => void;
    onAreaSelectEnd: (event: MouseEvent) => void;
    onPageLoad: () => void;
    onPageRender: () => void;
    onMouseDown: (event: React.PointerEvent<HTMLDivElement>) => void;
    onMouseMove: (event: MouseEvent) => void;
    onMouseUp: (event: MouseEvent) => void;
    renderSelections: () => JSX.Element | null;
    render: () => JSX.Element;
}
export {};
