"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PdfViewer = exports.isAreaSelection = void 0;
var react_1 = __importStar(require("react"));
var react_pdf_1 = require("react-pdf");
require("react-pdf/dist/esm/Page/AnnotationLayer.css");
var debounce_1 = require("../../dist/utils/debounce");
require("../style/react_pdf_viewer.css");
var utils_1 = require("../utils");
var coordinates_1 = require("../utils/coordinates");
var PdfPage_1 = require("./PdfPage");
var isAreaSelection = function (selection) { return "image" in selection; };
exports.isAreaSelection = isAreaSelection;
react_pdf_1.pdfjs.GlobalWorkerOptions.workerSrc = "//cdnjs.cloudflare.com/ajax/libs/pdf.js/" + react_pdf_1.pdfjs.version + "/pdf.worker.min.js";
var PdfViewer = /** @class */ (function (_super) {
    __extends(PdfViewer, _super);
    function PdfViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            textSelectionEnabled: true,
            numPages: 0,
        };
        /** Total left and right border width, needed as offset to avoid PageCanvas rendering past right page border. */
        _this.BORDER_WIDTH_OFFSET = 18;
        _this.containerDiv = null;
        /**
         * Lifecycle function
         */
        _this.componentDidMount = function () {
            var _a;
            _this.computeSelectionMap();
            document.addEventListener("keydown", _this.onKeyDown);
            document.addEventListener("selectstart", _this.onTextSelectionStart);
            document.addEventListener("selectionchange", _this.onTextSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.addEventListener("resize", _this.debouncedSetContainerWidth);
            // debug
            window.PdfViewer = _this;
        };
        _this.componentDidUpdate = function (nextProps) {
            if (_this.props.selections !== nextProps.selections)
                _this.computeSelectionMap();
        };
        _this.componentWillUnmount = function () {
            var _a;
            document.removeEventListener("keydown", _this.onKeyDown);
            document.removeEventListener("selectstart", _this.onTextSelectionStart);
            document.removeEventListener("selectionchange", _this.onTextSelectionChange);
            (_a = document.defaultView) === null || _a === void 0 ? void 0 : _a.removeEventListener("resize", _this.debouncedSetContainerWidth);
        };
        /**
         * Helpers
         */
        _this.resetSelections = function () {
            _this.clearTextSelection();
            _this.clearAreaSelection();
        };
        _this.computeSelectionMap = function () {
            if (!_this.props.selections) {
                _this.selectionMap = undefined;
                return;
            }
            var selectionMap = {};
            _this.props.selections.forEach(function (selection) {
                var _a;
                selectionMap[selection.position.pageNumber] = __spreadArrays((_a = selectionMap[selection.position.pageNumber]) !== null && _a !== void 0 ? _a : [], [
                    selection,
                ]);
            });
            _this.selectionMap = selectionMap;
        };
        _this.setContainerWidth = function () {
            if (!_this.containerDiv)
                return;
            _this.setState({
                containerWidth: _this.containerDiv.getBoundingClientRect().width - _this.BORDER_WIDTH_OFFSET,
            });
        };
        _this.debouncedSetContainerWidth = debounce_1.debounce(_this.setContainerWidth, 500);
        /**
         * Text selection handlers
         */
        _this.clearTextSelection = function () {
            var _a, _b, _c;
            (_a = utils_1.getWindow(_this.containerDiv).getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges();
            (_c = (_b = _this.props).onTextSelection) === null || _c === void 0 ? void 0 : _c.call(_b);
        };
        _this.onTextSelectionStart = function () {
            _this.clearAreaSelection();
        };
        _this.onTextSelectionChange = function () {
            var _a, _b;
            var selection = utils_1.getWindow(_this.containerDiv).getSelection();
            if (!selection || selection.isCollapsed)
                return;
            var range = selection.rangeCount > 0 ? selection.getRangeAt(0) : undefined;
            if (!range)
                return;
            var page = utils_1.getPageFromRange(range);
            if (!page)
                return;
            var pageDimension = { width: page.node.clientWidth, height: page.node.clientHeight };
            var rects = utils_1.getClientRects(range, page.node);
            if (rects.length === 0)
                return;
            var boundingRect = utils_1.getBoundingRect(rects);
            var position = coordinates_1.normalizePosition({ boundingRect: boundingRect, rects: rects, pageNumber: page.number }, pageDimension);
            var text = Array.from(range.cloneContents().childNodes).reduce(function (a, b) { return a + " " + b.textContent; }, "");
            (_b = (_a = _this.props).onTextSelection) === null || _b === void 0 ? void 0 : _b.call(_a, { position: position, text: text });
        };
        /**
         * Area selection handlers
         */
        _this.clearAreaSelection = function () {
            var _a, _b;
            _this.setState({ areaSelectionActivePage: undefined, textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a);
        };
        _this.onAreaSelectionStart = function (pageNumber) {
            _this.clearTextSelection();
            _this.setState({ textSelectionEnabled: false, areaSelectionActivePage: pageNumber });
        };
        _this.onAreaSelectionEnd = function (selection) {
            var _a, _b;
            _this.setState({ textSelectionEnabled: true });
            (_b = (_a = _this.props).onAreaSelection) === null || _b === void 0 ? void 0 : _b.call(_a, selection);
        };
        /**
         * Event handlers
         */
        _this.onKeyDown = function (event) {
            if (event.key === "Escape")
                _this.resetSelections();
        };
        _this.onMouseDown = function () {
            _this.resetSelections();
        };
        _this.onDocumentLoad = function (_a) {
            var numPages = _a.numPages;
            _this.setContainerWidth();
            _this.setState({ numPages: numPages });
        };
        _this.render = function () {
            var _a = _this.state, areaSelectionActivePage = _a.areaSelectionActivePage, containerWidth = _a.containerWidth, numPages = _a.numPages;
            return (react_1.default.createElement("div", { ref: function (ref) { return _this.containerDiv = ref; }, style: {
                    position: "relative",
                    width: "100%",
                }, onContextMenu: function (e) { return e.preventDefault(); }, onPointerDown: _this.onMouseDown },
                react_1.default.createElement(react_pdf_1.Document, { file: _this.props.url, onLoadSuccess: _this.onDocumentLoad, options: { removePageBorders: false } }, Array.from(new Array(5), function (el, index) {
                    var _a;
                    return (react_1.default.createElement(PdfPage_1.PdfPage, { key: index, pageNumber: index + 1, width: containerWidth, selections: (_a = _this.selectionMap) === null || _a === void 0 ? void 0 : _a[index + 1], areaSelectionActive: areaSelectionActivePage ? areaSelectionActivePage === index + 1 : false, enableAreaSelection: _this.props.enableAreaSelection, onAreaSelectionStart: _this.onAreaSelectionStart, onAreaSelectionEnd: _this.onAreaSelectionEnd }));
                })),
                _this.props.children));
        };
        return _this;
    }
    return PdfViewer;
}(react_1.Component));
exports.PdfViewer = PdfViewer;
